class ItemsController < ApplicationController
  before_filter :login_required

  def index
    @todo_items = current_user.items.find(:all, :conditions => ["done=?", false], :order => "sort desc")
    @done_items = current_user.items.find(:all, :conditions => ["done=?", true], :order => "sort desc")
  end

  def create
    item = Item.new(params[:item])
    item.user = current_user
    if item.save
      render :update do |page|
        page["item_content"].value = ""
        add_item page, item
      end
    else
      render :nothing => true
    end
  end
  
  def update_content
    item = current_user.items.find(params[:id])
    item.update_attribute :content, params[:value]
    render :text => item.content
  end

  def update_done
    item = current_user.items.find(params[:id])
    item.done = params[:done]
    item.move_to_last
    item.save!
    render :update do |page|
      remove_item page, item
      add_item page, item
    end
  end

  def destroy
    item = current_user.items.find(params[:id])
    item.destroy
    render :update do |page|
      remove_item page, item
    end
  end

  def sort
    ids = params[:items]
    ids.each_with_index do |id, i|
      current_user.items.find(id).update_attribute :sort, ids.size - i
    end
    render :nothing => true
  end
end
